unit FMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  StdCtrls, Buttons, ComCtrls, OleCtrls, Menus, Types, ExtCtrls, Spin, ZylNMEAGenerator;

type

  TfrmMain = class(TForm)
    gbLat: TGroupBox;
    btnGenerate: TBitBtn;
    cmbLat: TComboBox;
    lblDegree: TLabel;
    lblMinute: TLabel;
    lblSecond: TLabel;
    gbLong: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    cmbLong: TComboBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    efLatDeg: TSpinEdit;
    efLatMin: TSpinEdit;
    efLatSec: TSpinEdit;
    efLongDeg: TSpinEdit;
    efLongMin: TSpinEdit;
    efLongSec: TSpinEdit;
    efHeading: TSpinEdit;
    efSpeed: TSpinEdit;
    efAltitude: TSpinEdit;
    Memo1: TMemo;
    ZylNMEAGenerator: TZylNMEAGenerator;
    btnTransmit: TBitBtn;
    GroupBox1: TGroupBox;
    efPort: TComboBox;
    btnConnect: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure btnGenerateClick(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnTransmitClick(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
 
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  cmbLat.ItemIndex := 0;
  cmbLong.ItemIndex := 0;
end;

procedure TfrmMain.btnGenerateClick(Sender: TObject);
begin
  ZylNMEAGenerator.Latitude_Degree := efLatDeg.Value;
  ZylNMEAGenerator.Latitude_Minute := efLatMin.Value;
  ZylNMEAGenerator.Latitude_Second := efLatSec.Value;
  if cmbLat.Text = 'North' then
    ZylNMEAGenerator.Latitude_Direction := cpNorth
  else
    ZylNMEAGenerator.Latitude_Direction := cpSouth;
  ZylNMEAGenerator.Longitude_Degree := efLongDeg.Value;
  ZylNMEAGenerator.Longitude_Minute := efLongMin.Value;
  ZylNMEAGenerator.Longitude_Second := efLongSec.Value;
  if cmbLong.Text = 'East' then
    ZylNMEAGenerator.Longitude_Direction := cpEast
  else
    ZylNMEAGenerator.Longitude_Direction := cpWest;
  ZylNMEAGenerator.Altitude := efAltitude.Value;
  ZylNMEAGenerator.Heading := efHeading.Value;
  ZylNMEAGenerator.Speed := ZylNMEAGenerator.KmhToKnots(efSpeed.Value);

  Memo1.Lines.Text := ZylNMEAGenerator.GetNMEA;
end;

procedure TfrmMain.btnConnectClick(Sender: TObject);
begin
  ZylNMEAGenerator.Connect(efPort.Text);
end;

procedure TfrmMain.btnTransmitClick(Sender: TObject);
begin
  ZylNMEAGenerator.Transmit;
end;

end.
